Index: trunk/VUT/GtpVisibilityPreprocessor/src/RssTree.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/RssTree.cpp	(revision 485)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/RssTree.cpp	(revision 492)
@@ -1,3 +1,2 @@
-
 // ================================================================
 // $Id: lsds_kdtree.cpp,v 1.18 2005/04/16 09:34:21 bittner Exp $
@@ -25,4 +24,8 @@
 #include "Ray.h"
 #include "Containers.h"
+#include "ViewCell.h"
+#include "Exporter.h"
+#include "Preprocessor.h"
+#include "SceneGraph.h"
 
 #define DEBUG_SPLIT_COST 0
@@ -64,4 +67,37 @@
 }
 
+inline void
+AddViewcells2Pvs(const ViewCellContainer &viewcells,
+				 const int side,
+				 int &viewcellsBack,
+				 int &viewcellsFront)
+{
+  ViewCellContainer::const_iterator it = viewcells.begin();
+  
+  for (; it != viewcells.end(); ++it) {
+	ViewCell *viewcell = *it;
+	if (side <= 0) {
+	  if (!viewcell->Mailed() && !viewcell->Mailed(2)) {
+		viewcellsBack++;
+		if (viewcell->Mailed(1))
+		  viewcell->Mail(2);
+		else
+		  viewcell->Mail();
+	  }
+	}
+	
+	if (side >= 0) {
+	  if (!viewcell->Mailed(1) && !viewcell->Mailed(2)) {
+		viewcellsFront++;
+		if (viewcell->Mailed())
+		  viewcell->Mail(2);
+		else
+		  viewcell->Mail(1);
+	  }
+	}
+  }
+}
+
+
 // Constructor
 RssTree::RssTree()
@@ -85,9 +121,7 @@
   environment->GetFloatValue("RssTree.maxStaticMemory", maxStaticMemory);
   
-  
-
-
-  float refDirAngle;
-  environment->GetFloatValue("RssTree.refDirAngle", refDirAngle);
+  environment->GetFloatValue("RssTree.maxStaticMemory", maxStaticMemory);
+
+
   
   environment->GetIntValue("RssTree.accessTimeThreshold", accessTimeThreshold);
@@ -125,4 +159,8 @@
   environment->GetIntValue("RssTree.dirSplitDepth", mDirSplitDepth);
 
+  environment->GetBoolValue("RssTree.importanceBasedCost", mImportanceBasedCost);
+  
+  environment->GetIntValue("RssTree.maxRays", mMaxRays);
+
   root = NULL;
   
@@ -143,5 +181,5 @@
 RssStatistics::Print(ostream &app) const
 {
-  app << "===== RssTree statistics ===============\n";
+  app << "###### RssTree statistics ######\n";
 
   app << "#N_RAYS ( Number of rays )\n"
@@ -204,5 +242,5 @@
       << Time() << " \n";
 
-  app << "===== END OF RssTree statistics ==========\n";
+  app << "###### END OF RssTree statistics ######\n";
 
 }
@@ -210,31 +248,23 @@
 
 void
-RssTreeLeaf::UpdatePvsSize()
-{
-  if (!mValidPvs) {
+RssTree::UpdatePvsSize(RssTreeLeaf *leaf)
+{
+  if (!leaf->mValidPvs) {
 	Intersectable::NewMail();
 	int pvsSize = 0;
-	for(RssTreeNode::RayInfoContainer::iterator ri = rays.begin();
-		ri != rays.end();
+	for(RssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+		ri != leaf->rays.end();
 		ri++)
 	  if ((*ri).mRay->IsActive()) {
 		Intersectable *object;
-#if BIDIRECTIONAL_RAY
-		object = (*ri).mRay->mOriginObject;
+		object = (*ri).GetObject();
 		if (object && !object->Mailed()) {
 		  pvsSize++;
 		  object->Mail();
 		}
-#endif
-		object = (*ri).mRay->mTerminationObject;
-		if (object && !object->Mailed()) {
-		  pvsSize++;
-		  object->Mail();
-		}
-	  }
-	mPvsSize = pvsSize;
-	mValidPvs = true;
-
-	ComputeEntropyImportance();
+	  }
+	leaf->SetPvsSize(pvsSize);
+	
+	ComputeImportance(leaf);
   }
 }
@@ -248,7 +278,9 @@
   float tmin, tmax;
   static Ray ray;
-  ray.Init(rayInfo.mRay->GetOrigin(), rayInfo.mRay->GetDir(), Ray::LINE_SEGMENT);
-  box.ComputeMinMaxT(ray, &tmin, &tmax);
-  if (tmin >= tmax)
+  cerr<<"Clip not reimplented yet...Quiting\n";
+  exit(1);
+  ray.Init(rayInfo.GetOrigin(), rayInfo.GetDir(), Ray::LINE_SEGMENT);
+
+  if (!box.ComputeMinMaxT(ray, &tmin, &tmax) || tmin>=tmax)
 	return false;
   
@@ -281,5 +313,6 @@
   if (root)
     delete root;
-	
+
+  
   root = new RssTreeLeaf(NULL, rays.size());
   // first construct a leaf that will get subdivide
@@ -315,6 +348,10 @@
 					);
   }
-	
-	
+  
+  // make the z axis (unused) a unit size
+  // important for volume computation
+  dirBBox.SetMin(2, 0.0f);
+  dirBBox.SetMax(2, 1.0f);
+  
   if ( forcedBoundingBox ) 
 	bbox = *forcedBoundingBox;
@@ -324,6 +361,5 @@
 
   stat.rays = leaf->rays.size();
-  leaf->UpdatePvsSize();
-  leaf->ComputeEntropyImportance();
+  UpdatePvsSize(leaf);
 
   stat.initialPvsSize = leaf->GetPvsSize();
@@ -338,8 +374,8 @@
   
   stat.Stop();
-
   stat.Print(cout);
   cout<<"#Total memory="<<GetMemUsage()<<endl;
 
+  // this rotine also updates importances etc...
 }
 
@@ -387,4 +423,6 @@
 	  if (!node->IsLeaf()) {
 		subdivided++;
+
+		
 		RssTreeInterior *interior = (RssTreeInterior *) node;
 		// push the children on the stack
@@ -482,28 +520,20 @@
 					 RssTreeLeaf *leaf,
 					 const AxisAlignedBox3 &box,
-					 float &position,
-					 int &raysBack,
-					 int &raysFront,
-					 int &pvsBack,
-					 int &pvsFront
+					 SplitInfo &info
 					 )
 {
 
-  int minDirDepth = 6;
-  int axis;
-  float costRatio;
-	
-  costRatio = BestCostRatio(leaf,
-							axis,
-							position,
-							raysBack,
-							raysFront,
-							pvsBack,
-							pvsFront
-							);
+  BestCostRatio(leaf,
+				info);
+  
 #if DEBUG_SPLIT_COST
-  cout<<axis<<" r="<<costRatio<<endl;
+  Debug<<"Split Info:"<<endl;
+  Debug<<"axis="<<info.axis<<" ratio="<<info.costRatio<<endl;
+  Debug<<"viewcells="<<info.viewCells<<
+	" viewcells back="<<info.viewCellsBack<<
+	" viewcells back="<<info.viewCellsFront<<endl;
 #endif
-  if (costRatio > termMaxCostRatio) {
+  
+  if (info.costRatio > termMaxCostRatio) {
 	//		cout<<"Too big cost ratio "<<costRatio<<endl;
 	stat.maxCostRatioNodes++;
@@ -516,36 +546,29 @@
 	" rays="<<leaf->rays.size()<<
 	" rc="<<leaf->GetAvgRayContribution()<<
-	" axis="<<axis<<endl;
+	" axis="<<info.axis<<endl;
 #endif
-	
-  return axis;
-}
-
-
-float
+  
+  return info.axis;
+}
+
+
+void
 RssTree::GetCostRatio(
 					  RssTreeLeaf *leaf,
-					  const int axis,
-					  const float position,
-					  const int raysBack,
-					  const int raysFront,
-					  const int pvsBack,
-					  const int pvsFront
+					  SplitInfo &info
 					  )
 {
-  bool costImportance = true;
-
-  float ratio;
+
   AxisAlignedBox3 box;
   float minBox, maxBox;
 
-  if (axis < 3) {
+  if (info.axis < 3) {
 	box = GetBBox(leaf);
-	minBox = box.Min(axis);
-	maxBox = box.Max(axis);
+	minBox = box.Min(info.axis);
+	maxBox = box.Max(info.axis);
   }	else {
 	box = GetDirBBox(leaf);
-	minBox = box.Min(axis-3);
-	maxBox = box.Max(axis-3);
+	minBox = box.Min(info.axis-3);
+	maxBox = box.Max(info.axis-3);
   }
 	
@@ -554,145 +577,172 @@
   int pvsSize = leaf->GetPvsSize();
 
-  if (!costImportance) {
-	//		float sum = raysBack*(position - minBox) + raysFront*(maxBox - position);
-	float sum = pvsBack*(position - minBox) + pvsFront*(maxBox - position);
-	float newCost = ct_div_ci + sum/sizeBox;
-	float oldCost = pvsSize;
-	ratio = newCost/oldCost;
+  if (!mImportanceBasedCost) {
+	const int costMethod = 0;
+	
+	switch (costMethod) {
+	case 0: {
+	  //		float sum = raysBack*(position - minBox) + raysFront*(maxBox - position);
+	  float sum = info.pvsBack*(info.position - minBox) + info.pvsFront*(maxBox - info.position);
+	  float newCost = ct_div_ci + sum/sizeBox;
+	  float oldCost = pvsSize;
+	  info.costRatio = newCost/oldCost;
+	  break;
+	}
+	case 1: {
+	  float newContrib =
+		info.contributionBack/(info.position - minBox) + 
+		+
+		info.contributionFront/(maxBox - info.position);
+	  float oldContrib = info.contribution/sizeBox;
+	  info.costRatio = oldContrib/newContrib;
+	  break;
+	} 
+	case 2: {
+	  float sum =
+		info.viewCellsBack*(info.position - minBox) +
+		info.viewCellsFront*(maxBox - info.position);
+	  float newCost = ct_div_ci + sum/sizeBox;
+	  float oldCost = info.viewCells;
+	  info.costRatio = newCost/oldCost;
+	  break;
+	}
+	case 3: {
+	  float newCost = info.raysBack*info.pvsBack  + info.raysFront*info.pvsFront;
+	  float oldCost = leaf->rays.size()*pvsSize;
+	  info.costRatio = newCost/oldCost;
+	}
+	}
   } else {
+	const int costMethod = 1;
 	// importance based cost
-#if 0
-	float newContrib =
-	  ((position - minBox)*sqr(pvsBack/(raysBack + Limits::Small)) +
-	   (maxBox - position)*sqr(pvsFront/(raysFront + Limits::Small)))/sizeBox;
-		
-	//			float newContrib =
-	//				sqr(pvsBack/(raysBack + Limits::Small)) +
-	//				sqr(pvsFront/(raysFront + Limits::Small));
-	float oldContrib = sqr(leaf->GetAvgRayContribution());
-	ratio = oldContrib/newContrib;
-#else
-#if 1
-	float newCost = raysBack*pvsBack  + raysFront*pvsFront;
-	float oldCost = leaf->rays.size()*pvsSize;
-	ratio = newCost/oldCost;
-#else
-#if 0
-	float newCost = (pvsBack  + pvsFront)*0.5f;
-	float oldCost = pvsSize;
-	ratio = newCost/oldCost;
-#else
-	float newCost = abs(raysBack  - raysFront);
-	float oldCost = leaf->rays.size();
-	ratio = newCost/oldCost;
-#endif
-#endif
-#endif
-  }
-	
-  return ratio;
+	switch (costMethod) {
+	case 0: {
+	  break;
+	}
+	case 1: {
+	  float newContrib =
+		sqr(info.pvsBack/(info.raysBack + Limits::Small)) +
+		sqr(info.pvsFront/(info.raysFront + Limits::Small));
+	  float oldContrib = sqr(leaf->GetAvgRayContribution());
+	  info.costRatio = oldContrib/newContrib;
+	  break;
+	}
+	case 2: {
+	  float newCost = (info.pvsBack  + info.pvsFront)*0.5f;
+	  float oldCost = pvsSize;
+	  info.costRatio = newCost/oldCost;
+	  break;
+	}
+	case 3: {
+	  float newCost = abs(info.raysBack  - info.raysFront);
+	  float oldCost = leaf->rays.size();
+	  info.costRatio = newCost/oldCost;
+	  break;
+	}
+  }
+  }
 }
 							
 
-float
+void
 RssTree::EvalCostRatio(
 					   RssTreeLeaf *leaf,
-					   const int axis,
-					   const float position,
-					   int &raysBack,
-					   int &raysFront,
-					   int &pvsBack,
-					   int &pvsFront
+					   SplitInfo &info
 					   )
 {
-  raysBack = 0;
-  raysFront = 0;
-  pvsFront = 0;
-  pvsBack = 0;
-
-	
+  info.raysBack = 0;
+  info.raysFront = 0;
+  info.pvsFront = 0;
+  info.pvsBack = 0;
+  info.viewCells = 0;
+  info.viewCellsFront = 0;
+  info.viewCellsBack = 0;
+
+
+  float sumWeights = Limits::Small;
+  float sumWeightsBack = Limits::Small;
+  float sumWeightsFront = Limits::Small;
+  
+  float sumContribution = 0.0f;
+  float sumContributionBack = 0.0f;
+  float sumContributionFront = 0.0f;
+
+  Intersectable::NewMail();
+
+  // count the numebr of viewcells first
+  for(RssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+	  ri != leaf->rays.end();
+	  ri++)
+	if ((*ri).mRay->IsActive()) {
+	  ViewCellContainer::const_iterator it = (*ri).mRay->mViewCells.begin();
+	  for (; it != (*ri).mRay->mViewCells.end(); ++it) {
+		if (!(*it)->Mailed()) {
+		  (*it)->Mail();
+		  info.viewCells++;
+		}
+	  }
+	}
+  
   Intersectable::NewMail(3);
-	
-  if (axis <= RssTreeNode::SPLIT_Z) {
-    // this is the main ray classification loop!
-    for(RssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-		ri != leaf->rays.end();
-		ri++)
-      if ((*ri).mRay->IsActive()) {
-				
-		// determine the side of this ray with respect to the plane
-		int side = (*ri).ComputeRaySide(axis, position);
-		//				(*ri).mRay->mSide = side;
-				
-		if (side <= 0)
-		  raysBack++;
-				
-		if (side >= 0)
-		  raysFront++;
-				
-		AddObject2Pvs((*ri).mRay->mTerminationObject, side, pvsBack, pvsFront);
-      }
-		
-  } else {
-		
-	// directional split
-    for(RssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-		ri != leaf->rays.end();
-		ri++)
-      if ((*ri).mRay->IsActive()) {
-				
-		// determine the side of this ray with respect to the plane
-		int side;
-		if ((*ri).mRay->GetDirParametrization(axis - 3) <= position)
-		  side = -1;
-		else
-		  side = 1;
-		
-		if (side <= 0)
-		  raysBack++;
-				
-		if (side >= 0)
-		  raysFront++;
-
-		//				(*ri).mRay->mSide = side;
-		AddObject2Pvs((*ri).mRay->mTerminationObject, side, pvsBack, pvsFront);
-				
-      }
-  }
-
-  float ratio = GetCostRatio(
-							 leaf,
-							 axis,
-							 position,
-							 raysBack,
-							 raysFront,
-							 pvsBack,
-							 pvsFront);
-
+  
+  // this is the main ray classification loop!
+  for(RssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+	  ri != leaf->rays.end();
+	  ri++)
+	if ((*ri).mRay->IsActive()) {
+	  int side;
+	  
+	  
+	  // determine the side of this ray with respect to the plane
+	  side = (*ri).ComputeRaySide(info.axis, info.position);
+	  
+	  float weight, contribution;
+	  
+	  GetRayContribution(*ri, weight, contribution);
+	  sumWeights += weight;
+	  sumContribution += contribution;
+	  
+	  if (side <= 0) {
+		info.raysBack++;
+		sumWeightsBack += weight;
+		sumContributionBack += contribution;
+	  }
+	  
+	  if (side >= 0) {
+		info.raysFront++;
+		sumWeightsFront += weight;
+		sumContributionFront += contribution;
+	  }
+	  
+	  AddObject2Pvs((*ri).GetObject(), side, info.pvsBack, info.pvsFront);
+	  AddViewcells2Pvs((*ri).mRay->mViewCells,
+					   side,
+					   info.viewCellsBack,
+					   info.viewCellsFront);
+	}
+
+  info.contribution = sumContribution/sumWeights;
+  info.contributionBack = sumContributionBack/sumWeightsBack;
+  info.contributionFront = sumContributionFront/sumWeightsFront;
+  
+  GetCostRatio(
+			   leaf,
+			   info);
+  
   //	cout<<axis<<" "<<pvsSize<<" "<<pvsBack<<" "<<pvsFront<<endl;
   //  float oldCost = leaf->rays.size();
-
+  
   //	cout<<"ratio="<<ratio<<endl;
-
-  return ratio;
-}
-
-float
+}
+
+void
 RssTree::BestCostRatio(
 					   RssTreeLeaf *leaf,
-					   int &axis,
-					   float &position,
-					   int &raysBack,
-					   int &raysFront,
-					   int &pvsBack,
-					   int &pvsFront
+					   SplitInfo &info
 					   )
 {
-  int nRaysBack[6], nRaysFront[6];
-  int nPvsBack[6], nPvsFront[6];
-  float nPosition[6];
-  float nCostRatio[6];
+  SplitInfo nInfo[5];
   int bestAxis = -1;
-	
+  
   AxisAlignedBox3 sBox = GetBBox(leaf);
   AxisAlignedBox3 dBox = GetDirBBox(leaf);
@@ -700,66 +750,46 @@
   int sAxis = sBox.Size().DrivingAxis();
   int dAxis = dBox.Size().DrivingAxis() + 3;
-
-
+  
   float dirSplitBoxSize = 0.01f;
   bool allowDirSplit = Magnitude(sBox.Size())*dirSplitBoxSize < Magnitude(bbox.Size());
 		
   
-  for (axis = 0; axis < 5; axis++)
+  for (int axis = 0; axis < 5; axis++)
 	if (
 		(axis < 3 && (leaf->depth < mDirSplitDepth ||  mInterleaveDirSplits)) ||
 		(axis >= 3 && (leaf->depth >= mDirSplitDepth))
 		) {
+	  nInfo[axis].axis = axis;
 	  if (!mSplitUseOnlyDrivingAxis || axis == sAxis || axis == dAxis) {
 		
 		if (splitType == ESplitRegular) {
 		  if (axis < 3)
-			nPosition[axis] = (sBox.Min()[axis] + sBox.Max()[axis])*0.5f;
+			nInfo[axis].position = (sBox.Min()[axis] + sBox.Max()[axis])*0.5f;
 		  else
-			nPosition[axis] = (dBox.Min()[axis-3] + dBox.Max()[axis-3])*0.5f;
-		  
-		  nCostRatio[axis] = EvalCostRatio(leaf,
-										   axis,
-										   nPosition[axis],
-										   nRaysBack[axis],
-										   nRaysFront[axis],
-										   nPvsBack[axis],
-										   nPvsFront[axis]
-										   );
+			nInfo[axis].position = (dBox.Min()[axis-3] + dBox.Max()[axis-3])*0.5f;
+		  EvalCostRatio(leaf,
+						nInfo[axis]);
 		} else
 		  if (splitType == ESplitHeuristic) {
-			nCostRatio[axis] = EvalCostRatioHeuristic(
-													  leaf,
-													  axis,
-													  nPosition[axis],
-													  nRaysBack[axis],
-													  nRaysFront[axis],
-													  nPvsBack[axis],
-													  nPvsFront[axis]);
+			EvalCostRatioHeuristic(
+								   leaf,
+								   nInfo[axis]
+								   );
 		  } else
 			if (splitType == ESplitHybrid) {
 			  if (leaf->depth > 7)
-				nCostRatio[axis] = EvalCostRatioHeuristic(
-														  leaf,
-														  axis,
-														  nPosition[axis],
-														  nRaysBack[axis],
-														  nRaysFront[axis],
-														  nPvsBack[axis],
-														  nPvsFront[axis]);
+				EvalCostRatioHeuristic(
+									   leaf,
+									   nInfo[axis]
+									   );
 			  else {
 				if (axis < 3)
-				  nPosition[axis] = (sBox.Min()[axis] + sBox.Max()[axis])*0.5f;
+				  nInfo[axis].position = (sBox.Min()[axis] + sBox.Max()[axis])*0.5f;
 				else
-				  nPosition[axis] = (dBox.Min()[axis-3] + dBox.Max()[axis-3])*0.5f;
+				  nInfo[axis].position = (dBox.Min()[axis-3] + dBox.Max()[axis-3])*0.5f;
 				
-				nCostRatio[axis] = EvalCostRatio(leaf,
-												 axis,
-												 nPosition[axis],
-												 nRaysBack[axis],
-												 nRaysFront[axis],
-												 nPvsBack[axis],
-												 nPvsFront[axis]
-												 );
+				EvalCostRatio(leaf,
+							  nInfo[axis]
+							  );
 			  }
 			} else {
@@ -768,35 +798,20 @@
 			}
 		
-		
 		if ( bestAxis == -1)
 		  bestAxis = axis;
 		else
-		  if ( nCostRatio[axis] < nCostRatio[bestAxis] )
+		  if ( nInfo[axis].costRatio < nInfo[bestAxis].costRatio )
 			bestAxis = axis;
 	  }
 	}
   
-  axis = bestAxis;
-  position = nPosition[bestAxis];
-
-  raysBack = nRaysBack[bestAxis];
-  raysFront = nRaysFront[bestAxis];
-
-  pvsBack = nPvsBack[bestAxis];
-  pvsFront = nPvsFront[bestAxis];
-	
-  return nCostRatio[bestAxis];
-}
-
-	
-float
+  info = nInfo[bestAxis];
+}
+
+	
+void
 RssTree::EvalCostRatioHeuristic(
 								RssTreeLeaf *leaf,
-								const int axis,
-								float &bestPosition,
-								int &raysBack,
-								int &raysFront,
-								int &pvsBack,
-								int &pvsFront
+								SplitInfo &info
 								)
 {
@@ -804,29 +819,40 @@
   float minBox, maxBox;
 	
-  if (axis < 3) {
+  if (info.axis < 3) {
 	box = GetBBox(leaf);
-	minBox = box.Min(axis);
-	maxBox = box.Max(axis);
+	minBox = box.Min(info.axis);
+	maxBox = box.Max(info.axis);
   } else {
 	box = GetDirBBox(leaf);
-	minBox = box.Min(axis-3);
-	maxBox = box.Max(axis-3);
-  }
-	
-  SortSplitCandidates(leaf, axis);
+	minBox = box.Min(info.axis-3);
+	maxBox = box.Max(info.axis-3);
+  }
+	
+  SortSplitCandidates(leaf, info.axis);
   
   // go through the lists, count the number of objects left and right
   // and evaluate the following cost funcion:
   // C = ct_div_ci  + (ql*rl + qr*rr)/queries
-	
-  int rl=0, rr = leaf->rays.size();
-  int pl=0, pr = leaf->GetPvsSize();
+  
+  SplitInfo currInfo;
+  currInfo.axis = info.axis;
+
+  currInfo.raysBack = 0;
+  currInfo.raysFront = leaf->rays.size();
+  
+  currInfo.pvsBack = 0;
+  currInfo.pvsFront = leaf->GetPvsSize();
+
+ 
   float sizeBox = maxBox - minBox;
-	
+  
   float minBand = minBox + 0.1f*(maxBox - minBox);
   float maxBand = minBox + 0.9f*(maxBox - minBox);
 	
-  float minRatio = 1e20f;
-	
+  // best cost ratio
+  info.costRatio = 1e20f;
+
+  currInfo.viewCells = 0;
+
   Intersectable::NewMail();
   // set all object as belonging to the fron pvs
@@ -835,5 +861,5 @@
 	  ri++)
 	if ((*ri).mRay->IsActive()) {
-	  Intersectable *object = (*ri).mRay->mTerminationObject;
+	  Intersectable *object = (*ri).GetObject();
 	  if (object)
 		if (!object->Mailed()) {
@@ -842,6 +868,22 @@
 		} else
 		  object->mCounter++;
-	}
-	
+	  
+	  // and do the same for all viewcells
+	  ViewCellContainer::const_iterator it = (*ri).mRay->mViewCells.begin();
+	  
+	  for (; it != (*ri).mRay->mViewCells.end(); ++it) {
+		ViewCell *viewcell = *it;
+		if (!viewcell->Mailed()) {
+		  currInfo.viewCells++;
+		  viewcell->Mail();
+		  viewcell->mCounter = 1;
+		} else
+		  viewcell->mCounter++;
+	  }
+	}
+
+  currInfo.viewCellsBack = 0;
+  currInfo.viewCellsFront = currInfo.viewCells;
+ 
   Intersectable::NewMail();
 	
@@ -849,18 +891,27 @@
 	  ci < splitCandidates->end();
 	  ci++) {
-	VssRay *ray;
 	switch ((*ci).type) {
 	case SortableEntry::ERayMin: {
-	  rr--;
-	  rl++;
-	  ray = (VssRay *) (*ci).data;
-	  Intersectable *object = ray->mTerminationObject;
+	  currInfo.raysFront--;
+	  currInfo.raysBack++;
+	  RssTreeNode::RayInfo *rayInfo = (RssTreeNode::RayInfo *) (*ci).data;
+	  Intersectable *object = rayInfo->GetObject();
 	  if (object) {
 		if (!object->Mailed()) {
 		  object->Mail();
-		  pl++;
+		  currInfo.pvsBack++;
 		}
 		if (--object->mCounter == 0)
-		  pr--;
+		  currInfo.pvsFront--;
+	  }
+	  ViewCellContainer::const_iterator it = rayInfo->mRay->mViewCells.begin();
+	  for (; it != rayInfo->mRay->mViewCells.end(); ++it) {
+		ViewCell *viewcell = *it;
+		if (!viewcell->Mailed()) {
+		  viewcell->Mail();
+		  currInfo.viewCellsBack++;
+		}
+		if (--viewcell->mCounter == 0)
+		  currInfo.viewCellsFront--;
 	  }
 	  break;
@@ -871,37 +922,24 @@
 	
 	if (position > minBand && position < maxBand) {
-			
-	  float ratio = GetCostRatio(
-								 leaf,
-								 axis,
-								 position,
-								 rl,
-								 rr,
-								 pl,
-								 pr);
-			
+	  currInfo.position = position;
+	  
+	  GetCostRatio(
+				   leaf,
+				   currInfo);
+	  
 			
 	  //      cout<<"pos="<<(*ci).value<<"\t q=("<<ql<<","<<qr<<")\t r=("<<rl<<","<<rr<<")"<<endl;
 	  //      cout<<"cost= "<<sum<<endl;
-			
-	  if (ratio < minRatio) {
-		minRatio = ratio;
-		bestPosition = position;
-				
-		raysBack = rl;
-		raysFront = rr;
-				
-		pvsBack = pl;
-		pvsFront = pr;
-				
+	  
+	  if (currInfo.costRatio < info.costRatio) {
+		info = currInfo;
       }
     }
   }
-
+  
   
   //  cout<<"===================="<<endl;
   //  cout<<"costRatio="<<ratio<<" pos="<<position<<" t="<<(position - minBox)/(maxBox - minBox)
   //      <<"\t q=("<<queriesBack<<","<<queriesFront<<")\t r=("<<raysBack<<","<<raysFront<<")"<<endl;
-  return minRatio;
 }
 
@@ -933,12 +971,12 @@
 	  if (axis < 3) {
 		splitCandidates->push_back(SortableEntry(SortableEntry::ERayMin,
-												 (*ri).ExtrapOrigin(axis),
-												 (void *)(*ri).mRay)
+												 (*ri).GetOrigin(axis),
+												 (void *)&(*ri))
 								   );
 	  } else {
-		float pos = (*ri).mRay->GetDirParametrization(axis-3);
+		float pos = (*ri).GetDirParametrization(axis-3);
 		splitCandidates->push_back(SortableEntry(SortableEntry::ERayMin,
 												 pos,
-												 (void *)(*ri).mRay)
+												 (void *)&(*ri))
 								   );
 	  }
@@ -1012,15 +1050,12 @@
   }
 	
-  float position;
-	
-  // first count ray sides
-  int raysBack;
-  int raysFront;
-  int pvsBack;
-  int pvsFront;
+  SplitInfo info;
 	
   // select subdivision axis
-  int axis = SelectPlane( leaf, box, position, raysBack, raysFront, pvsBack, pvsFront);
-  Debug<<"axis="<<axis<<" depth="<<(int)leaf->depth<<" rb="<<raysBack<<" rf="<<raysFront<<" pvsb="<<pvsBack<<" pvsf="<<pvsFront<<endl;
+  int axis = SelectPlane( leaf,
+						  box,
+						  info
+						  );
+  //  Debug<<"axis="<<axis<<" depth="<<(int)leaf->depth<<" rb="<<raysBack<<" rf="<<raysFront<<" pvsb="<<pvsBack<<" pvsf="<<pvsFront<<endl;
   
   if (axis == -1) {
@@ -1035,5 +1070,5 @@
 
   node->axis = axis;
-  node->position = position;
+  node->position = info.position;
   node->bbox = box;
   node->dirBBox = GetDirBBox(leaf);
@@ -1041,8 +1076,12 @@
   backBBox = box;
   frontBBox = box;
-
-  RssTreeLeaf *back = new RssTreeLeaf(node, raysBack);
-  RssTreeLeaf *front = new RssTreeLeaf(node, raysFront);
-
+  
+  RssTreeLeaf *back = new RssTreeLeaf(node, info.raysBack);
+  RssTreeLeaf *front = new RssTreeLeaf(node, info.raysFront);
+
+  // update halton generator
+  back->halton.index = leaf->halton.index;
+  front->halton.index = leaf->halton.index;
+  
   // replace a link from node's parent
   if (  leaf->parent )
@@ -1052,62 +1091,35 @@
 	
   if (axis <= RssTreeNode::SPLIT_Z) {
-	backBBox.SetMax(axis, position);
-    frontBBox.SetMin(axis, position);
-		
-	for(RssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-		ri != leaf->rays.end();
-		ri++) {
-      if ((*ri).mRay->IsActive()) {
-				
-		// first unref ray from the former leaf
-		(*ri).mRay->Unref();
-
-		// Debug << "computed t: " << (*ri).mRay->mT << endl;
-		// determine the side of this ray with respect to the plane
-		int side = node->ComputeRaySide(*ri);
-		
-		if (side == 0) {
-		  if ((*ri).mRay->HasPosDir(axis)) {
-			back->AddRay(*ri);
-			front->AddRay(*ri);
-		  } else {
-			back->AddRay(*ri);
-			front->AddRay(*ri);
-		  }
-		} else
-		  if (side == 1) 
-			front->AddRay(*ri);
-		  else
-			back->AddRay(*ri);
-      } else
-		(*ri).mRay->Unref();
-    }
-  } else {
-    // rays front/back
-    
-    
-    for(RssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
-		ri != leaf->rays.end();
-		ri++) {
-      if ((*ri).mRay->IsActive()) {
-		// first unref ray from the former leaf
-		(*ri).mRay->Unref();
-
-		int side;
-		if ((*ri).mRay->GetDirParametrization(axis - 3) <= position)
-		  side = -1;
-		else
-		  side = 1;
-				
-		if (side == 1)
-		  front->AddRay(*ri);
-		else
-		  back->AddRay(*ri);
-				
-      } else
-		(*ri).mRay->Unref();
-    }
-  }
-
+	backBBox.SetMax(axis, info.position);
+    frontBBox.SetMin(axis, info.position);
+  }
+
+  for(RssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+	  ri != leaf->rays.end();
+	  ri++) {
+	if ((*ri).mRay->IsActive()) {
+	  
+	  // first unref ray from the former leaf
+	  (*ri).mRay->Unref();
+	  
+	  // Debug << "computed t: " << (*ri).mRay->mT << endl;
+	  // determine the side of this ray with respect to the plane
+	  int side = node->ComputeRaySide(*ri);
+	  
+	  if (side == 1) 
+		front->AddRay(*ri);
+	  else
+		back->AddRay(*ri);
+	} else
+	  (*ri).mRay->Unref();
+  }
+
+  // distribute the total number of rays according to the distribution
+  // of rays which remained
+  
+  
+  //  front->mTotalRays = front->rays.size()*leaf->mTotalRays/leaf->rays.size();
+  //  back->mTotalRays = back->rays.size()*leaf->mTotalRays/leaf->rays.size();
+  
 #if 0
   front->SetPvsSize(pvsFront);
@@ -1117,6 +1129,6 @@
   back->ComputeEntropyImportance();
 #else
-  front->UpdatePvsSize();
-  back->UpdatePvsSize();
+  UpdatePvsSize(front);
+  UpdatePvsSize(back);
 #endif
 
@@ -1124,5 +1136,5 @@
   // update stats
   stat.rayRefs -= (int)leaf->rays.size();
-  stat.rayRefs += raysBack + raysFront;
+  stat.rayRefs += info.raysBack + info.raysFront;
 
   
@@ -1221,5 +1233,6 @@
 
 void
-RssTree::UpdateRays(VssRayContainer &remove,
+RssTree::UpdateRays(
+					VssRayContainer &remove,
 					VssRayContainer &add
 					)
@@ -1257,5 +1270,17 @@
 	  AddRay(info);
   }
-}
+
+  stat.rayRefs += add.size() - remove.size();
+
+  UpdateTreeStatistics();
+  // check whether the tree should be prunned
+  if (stat.rayRefs > mMaxRays) {
+	PruneRays(mMaxRays);
+	//	UpdateTreeStatistics();
+  }
+  
+}
+
+  
 
 
@@ -1377,46 +1402,13 @@
   RssTreeInterior *in =  (RssTreeInterior *) data.node;
   
-  if (in->axis <= RssTreeNode::SPLIT_Z) {
-
-    // determine the side of this ray with respect to the plane
-    int side = in->ComputeRaySide(data.rayData
-								  );
-    
-  
-    if (side == 0) {
-      if (data.rayData.mRay->HasPosDir(in->axis)) {
-		tstack.push(RayTraversalData(in->back,
-									 data.rayData)
-					);
-				
-		tstack.push(RayTraversalData(in->front,
-									 data.rayData)
-					);
-	
-      } else {
-		tstack.push(RayTraversalData(in->back,
-									 data.rayData
-									 )
-					);
-				
-		tstack.push(RayTraversalData(in->front,
-									 data.rayData)
-					);
-				
-				
-      }
-    } else
-      if (side == 1)
-		tstack.push(RayTraversalData(in->front, data.rayData));
-      else
-		tstack.push(RayTraversalData(in->back, data.rayData));
-  } 
-  else {
-    // directional split
-	if (data.rayData.mRay->GetDirParametrization(in->axis - 3) <= in->position)
-	  tstack.push(RayTraversalData(in->back, data.rayData));
-	else
-	  tstack.push(RayTraversalData(in->front, data.rayData));
-  }
+  // determine the side of this ray with respect to the plane
+  int side = in->ComputeRaySide(data.rayData
+								);
+  
+  if (side == 1)
+	tstack.push(RayTraversalData(in->front, data.rayData));
+  else
+	tstack.push(RayTraversalData(in->back, data.rayData));
+  
 }
 
@@ -1559,12 +1551,5 @@
 		if ((*ri).mRay->IsActive()) {
 		  Intersectable *object;
-#if BIDIRECTIONAL_RAY
-		  object = (*ri).mRay->mOriginObject;
-		  if (object && !object->Mailed()) {
-			pvsSize++;
-			object->Mail();
-		  }
-#endif
-		  object = (*ri).mRay->mTerminationObject;
+		  object = (*ri).GetObject();
 		  if (object && !object->Mailed()) {
 			pvsSize++;
@@ -1612,5 +1597,5 @@
 		if ((*ri).mRay->IsActive()) {
 		  Intersectable *object;
-		  object = (*ri).mRay->mTerminationObject;
+		  object = (*ri).GetObject();
 		  if (object && !object->Mailed()) {
 			pvs.push_back(object);
@@ -1637,12 +1622,5 @@
 
 void
-RssTree::GetTreeStatistics(
-						   float &avgPvsSize,
-						   float &avgRays,
-						   float &avgRayContribution,
-						   float &avgPvsEntropy,
-						   float &avgRayLengthEntropy,
-						   float &avgImportance
-						   )
+RssTree::UpdateTreeStatistics()
 {
   stack<RssTreeNode *> tstack;
@@ -1651,4 +1629,5 @@
   float sumPvsSize = 0.0f;
   float sumRayContribution = 0.0f;
+  float sumWeightedRayContribution = 0.0f;
   float sumImportance = 0.0f;
   float sumPvsEntropy = 0.0f;
@@ -1665,16 +1644,25 @@
 	  leaves++;
 	  RssTreeLeaf *leaf = (RssTreeLeaf *)node;
-	  leaf->UpdatePvsSize();
+	  UpdatePvsSize(leaf);
 	  
 	  sumPvsSize += leaf->GetPvsSize();
 	  sumRayContribution += leaf->GetAvgRayContribution();
-	  sumPvsEntropy += leaf->mPvsEntropy;
-	  sumRayLengthEntropy += leaf->mRayLengthEntropy;
+	  
+
+	  RssTreeNode::RayInfoContainer::const_iterator it = leaf->rays.begin();
+	  for (;it != leaf->rays.end(); ++it) {
+		float weight, contribution;
+		GetRayContribution(*it, weight, contribution);
+		sumWeightedRayContribution += weight*contribution;
+	  }
+	  
+	  //	  sumPvsEntropy += leaf->mPvsEntropy;
+	  //	  sumRayLengthEntropy += leaf->mRayLengthEntropy;
 	  sumRays += leaf->rays.size();
 	  
 	  float imp = leaf->GetImportance();
 	  
-	  if (imp > 1.0f)
-		cout<<"warning imp > 1.0f:"<<imp<<endl;
+	  //	  if (imp > 1.0f)
+	  //		cout<<"warning imp > 1.0f:"<<imp<<endl;
 	  
 	  sumImportance += imp;
@@ -1689,15 +1677,19 @@
   }
   
-  avgPvsSize = sumPvsSize/(float)leaves;
-  avgRays = sumRays/(float)leaves;
-  avgRayContribution = sumRayContribution/(float)leaves;
-  avgPvsEntropy = sumPvsEntropy/(float)leaves;
-  avgRayLengthEntropy = sumRayLengthEntropy/(float)leaves;
-  avgImportance = sumImportance/(float)leaves;
-}
+  stat.avgPvsSize = sumPvsSize/(float)leaves;
+  stat.avgRays = sumRays/(float)leaves;
+  stat.avgRayContribution = sumRayContribution/(float)leaves;
+  //  avgPvsEntropy = sumPvsEntropy/(float)leaves;
+  //  avgRayLengthEntropy = sumRayLengthEntropy/(float)leaves;
+  stat.avgImportance = sumImportance/(float)leaves;
+  stat.avgWeightedRayContribution = sumWeightedRayContribution/(float)sumRays;
+  stat.rayRefs = (int)sumRays;
+}
+
 
 
 int
-RssTree::GenerateRays(const float ratioPerLeaf,
+RssTree::GenerateRays(
+					  const float ratioPerLeaf,
 					  SimpleRayContainer &rays)
 {
@@ -1777,5 +1769,6 @@
 	return;
   }
-  
+
+#if 1
   int tries = min(20, nrays);
 
@@ -1783,5 +1776,5 @@
 	r1 = Random(nrays);
 	r2 = Random(nrays);
-	if (leaf->rays[r1].mRay->mTerminationObject != leaf->rays[r2].mRay->mTerminationObject)
+	if (leaf->rays[r1].GetObject() != leaf->rays[r2].GetObject())
 	  break;
   }
